"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BreadcrumbsComponent = void 0;
const components_1 = require("typedoc/dist/lib/output/components");
const theme_1 = require("../theme");
let BreadcrumbsComponent = class BreadcrumbsComponent extends components_1.ContextAwareRendererComponent {
    initialize() {
        super.initialize();
        const component = this;
        theme_1.default.HANDLEBARS.registerHelper('breadcrumbs', (page) => {
            var _a, _b, _c;
            const theme = this.application.renderer.theme;
            const breadcrumbs = [];
            if ((_a = this.project) === null || _a === void 0 ? void 0 : _a.readme) {
                breadcrumbs.push(page.url === theme.entryFile
                    ? 'README'
                    : `[README](${this.getRelativeUrl(theme.entryFile)})`);
            }
            breadcrumbs.push(page.url === ((_b = this.project) === null || _b === void 0 ? void 0 : _b.url)
                ? 'Globals'
                : `[Globals](${this.getRelativeUrl((_c = this.project) === null || _c === void 0 ? void 0 : _c.url)})`);
            return component.breadcrumb(page, page.model, breadcrumbs);
        });
    }
    breadcrumb(page, model, md) {
        if (model && model.parent) {
            this.breadcrumb(page, model.parent, md);
            if (model.url) {
                md.push(page.url === model.url
                    ? `${model.name}`
                    : `[${model.name}](${this.getRelativeUrl(model.url)})`);
            }
        }
        return md.join(' / ');
    }
};
BreadcrumbsComponent = __decorate([
    components_1.Component({ name: 'breadcrumbs' })
], BreadcrumbsComponent);
exports.BreadcrumbsComponent = BreadcrumbsComponent;
